<template>
<section class="section-event container">
  <p><router-link to="/">Афиша</router-link> / {{this.event.title}}</p>
  <hr>
  <p class="mb-0">{{this.event.type}} • {{this.event.min_age}}+</p>
  <h1 class="mb-3">{{this.event.title}}</h1>
  <p>Место: {{this.event.place}}</p>
  <p class="mb-0">Начало: {{this.event.begins_at | formatEventDate}}</p>
  <p>Продолжительность (в минутах): {{eventDuration}}</p>
  <hr>
  <p style="white-space: pre-line;">{{this.event.description}}</p>
  <img class="img-fluid mb-3" :src="this.event.cover" :alt="this.event.title">
  <p>Стоимость билета: <span class="fw-bold">{{this.event.price}}₽</span></p>
  <h2>Поторопитесь купить билеты, так как свободных мест осталось {{this.event.vacancies_amount}}</h2>
  <form class="d-flex justify-content-center mb-4" @submit.prevent="buyTickets">
    <label><span class="visually-hidden">Количество билетов: </span><input class="form-control me-2" type="number" min="1" :max="this.event.vacancies_amount" v-model="ticketsAmount"></label>
    <input class="btn btn-success" type="submit" value="Купить билет">
    <p class="text-danger" v-if="errorMessage">{{this.errorMessage}}</p>
  </form>
</section>
</template>

<script>
import axios from "axios";

export default {
  name: "Event",
  data() {
    return {
      event: {},
      ticketsAmount: 1,
      errorMessage: ''
    }
  },
  created() {
    this.fetchEvent()
  },
  methods: {
    fetchEvent() {
      axios
          .get('events/' + this.$route.params.id)
          .then(({data}) => {
            this.event = data
          })
    },
    buyTickets() {
      if (!localStorage.getItem('token')) {
        return this.$router.push({
          path: '/login',
          query: { redirect: this.$route.fullPath }
        })
      }
      axios
          .put(`events/${this.$route.params.id}/buy-ticket/`, {'tickets_amount': this.ticketsAmount})
          .then(({data: {message}}) => {
            if (message !== 'added') {
              return this.errorMessage = message
            }
            this.$router.push('/tickets')
          })
    }
  },
  filters: {
    formatEventDate(date) {
      const formatter = new Intl.DateTimeFormat("ru", {
        weekday: "short",
        month: "long",
        day: "2-digit",
        year: "numeric",
        hour: "2-digit",
        minute: "2-digit",
      });
      return date && formatter.format(new Date(date))
    }
  },
  computed: {
    eventDuration() {
      const start = new Date(this.event.begins_at)
      const end = new Date(this.event.ends_at)
      return `${(end - start) / 1000 / 60}`
    }
  }
}
</script>

<style lang="scss">
.form-control {
  display: inline-block;
  max-width: 67px;
}

nav {
  a {
    transition: color .7s;

    &:hover {
      color: #42b983;
    }
  }
}
.section-event {
  .router-link-active {
    font-weight: 700;
    color: #42b983;
    text-decoration: none;
  }
}

</style>